# Author: Raphaël Jacquot, Guillaume Mella
# Description: haproxy top of the configuration

global
    log                         127.0.0.1:514 len 4096 local0 debug
    log                         {{syslog_server_ip}}:514 len 4096 local0 debug
    chroot                      /var/lib/haproxy
    stats                       socket /run/haproxy/admin.sock mode 660 level admin
    stats                       timeout 30s
    user                        haproxy
    group                       haproxy
    tune.ssl.default-dh-param   2048
    daemon
    debug

    # We get some app  timeout with too many javaws+bots ?? on jan 2021 increase maxconn to 50000 and enable stat report
    maxconn 50000
    stats socket /var/run/haproxy/haproxy.sock mode 0600 level admin


    # SSL stuff goes here

defaults
    log                         global
    mode                        http

# https://www.haproxy.com/blog/haproxy-log-customization
#    option                      httplog
# default log-format "%ci:%cp [%tr] %ft %b/%s %TR/%Tw/%Tc/%Tr/%Ta %ST %B %CC %CS %tsc %ac/%fc/%bc/%sc/%rc %sq/%bq %hr %hs %{+Q}r"
# moved hr and hs at the end to find a way to grok all information using logstash capturing user-agent
log-format "%ci:%cp [%tr] %ft %b/%s %TR/%Tw/%Tc/%Tr/%Ta %ST %B %CC %CS %tsc %ac/%fc/%bc/%sc/%rc %sq/%bq %{+Q}r %hr %hs"

    option                      dontlognull
# provide client IP
    option forwardfor
    timeout                     connect 6s
    timeout                     client  10m
    timeout                     server  10m
    errorfile                   400     /etc/haproxy/errors/400.http
    errorfile                   403     /etc/haproxy/errors/403.http
    errorfile                   408     /etc/haproxy/errors/408.http
    errorfile                   500     /etc/haproxy/errors/500.http
    errorfile                   502     /etc/haproxy/errors/502.http
    errorfile                   503     /etc/haproxy/errors/503.http
    errorfile                   504     /etc/haproxy/errors/504.http
    
    maxconn 50000

## sample template configuration
## see https://serversforhackers.com/using-ssl-certificates-with-haproxy
#
#frontend localhost
#
## running http and https with the same rules just requires setting up 2 bind commands
#    bind *:80
#    bind *:443 ssl crt /etc/ssl/xip.io/xip.io.pem
#
## implementing HSTS requires the following : 
#    redirect scheme https if !{ ssl_fc }
## this is the mode required for http and https support on the same system, already set in the defaults above
#    mode http
#
## this option makes it so that the server shuts the connection each time, DDOS protection
#    option      http-server-close
#
## followed by backend definitions
#    default_backend nodes

frontend www
    bind        {{ansible_default_ipv4.address}}:80
    bind        {{ansible_default_ipv4.address}}:443 ssl crt /etc/haproxy/certs/cert.pem crt /etc/haproxy/certs/olbin_org.pem
# revert to default since we encountered client connection timeouts on LITpro/SearchCal
# old server option has been setup for this old backend (no keepalive support)
#    option      http-server-close

    # Redirect *.mariotti.fr to https://www.jmmc.fr
    acl notmainjmmc-host-acl hdr_end(host) -i mariotti.fr
    http-request redirect prefix https://www.jmmc.fr if notmainjmmc-host-acl
    # Always keep original req.host 
    http-request set-header X-Forwarded-Host %[req.hdr(Host)]

    # Capture Host and User-Agent
#    http-request capture req.hdr(Host) len 10
    http-request capture req.hdr(User-Agent) len 100



#/ LOG4J CVE-2021-44228
#
# https://www.haproxy.com/fr/blog/december-2021-log4shell-mitigation/
# modified to work with HAProxy 1.7
#
# this should be disabled later when everything that requires a log4j update is safe back
   option http-buffer-request
   acl log4shell url,url_dec -m reg \${[^}]*\${
#   acl log4shell url,url_dec -m reg \${jndi:(?:ldaps?|iiop|dns|rmi)://
   acl log4shell url,url_dec -m reg jndi:(?:ldaps?|iiop|dns|rmi)://
   acl log4shell url,url_dec -i -m reg \${[\w${}\-:]*j[\w${}\-:]*n[\w${}\-:]*d[\w${}\-:]*i[\w${}\-:]*:.*}

   acl log4shell hdr() -m reg \${[^}]*\${
#   acl log4shell hdr() -m reg \${jndi:(?:ldaps?|iiop|dns|rmi)://
   acl log4shell hdr() -m reg jndi:(?:ldaps?|iiop|dns|rmi)://
   acl log4shell hdr() -i -m reg \${[\w${}\-:]*j[\w${}\-:]*n[\w${}\-:]*d[\w${}\-:]*i[\w${}\-:]*:.*}

   acl log4shell_form req.body -m reg \${[^}]*\${
   acl log4shell_form req.body -m reg \${jndi:(?:ldaps?|iiop|dns|rmi)://
   acl log4shell_form req.body -i -m reg \${[\w${}\-:]*j[\w${}\-:]*n[\w${}\-:]*d[\w${}\-:]*i[\w${}\-:]*:.*}

   http-request deny if log4shell
   http-request deny if log4shell_form

